#include <QApplication>
#include <QFileDialog>
#include <QLabel>

#include "mirroredimagefilter.h"
#include "rotatedimagefilter.h"

int main( int argc, char** argv ) {
    QApplication app( argc, argv );
    QString fileName = QFileDialog::getOpenFileName(
        nullptr,
        "Load Image",
        QString(),
        "Images (*.jpg *.png *.bmp)"
    );

    QPixmap pix;
    if( pix.load( fileName ) ) {
        QLabel lblMirrored;
        lblMirrored.setPixmap( MirroredImageFilter().apply( pix ) );
        lblMirrored.show();

        QLabel lblRotated;
        lblRotated.setPixmap( RotatedImageFilter().apply( pix ) );
        lblRotated.show();

        QLabel lblCombined;
        lblCombined.setPixmap(
            RotatedImageFilter( 45.0, std::make_shared< MirroredImageFilter >() ).apply( pix )
        );
        lblCombined.show();

        return app.exec();
    }


    return 0;
}
