#include "mirroredimagefilter.h"

MirroredImageFilter::MirroredImageFilter( const std::shared_ptr< ImageFilter >& filter ) : m_filter( filter ) {
}

QPixmap MirroredImageFilter::apply( const QPixmap& pix ) {
    QPixmap pixResult = pix;
    if( m_filter ) {
        pixResult = m_filter->apply( pix );
    }

    return QPixmap::fromImage( pixResult.toImage().mirrored( true, false ) );
}
