#include "rotatedimagefilter.h"

RotatedImageFilter::RotatedImageFilter( double angle, const std::shared_ptr< ImageFilter >& filter ) :
    m_angle( angle ), m_filter( filter ) {
}

QPixmap RotatedImageFilter::apply( const QPixmap& pix ) {
    QPixmap pixResult = pix;
    if( m_filter ) {
        pixResult = m_filter->apply( pix );
    }

    return pixResult.transformed( QTransform().rotate( m_angle ) );
}
